
# Content-Invariant Constraint for Unsupervised Image-to-Image Translation

This repository is the official implementation of [Content-Invariant Constraint for Unsupervised Image-to-Image Translation]. 


## Requirements

* **PyTorch 1.3.0**
* Python 3.6.5


## Training

To train the Digits (SVHN->MNIST) CycleGAN model(s) with our CIC in the paper, run this command:

```train
python main.py --geometry=1 --lambda_MI=22 
```
geometry:
   * 0: GAN 
   * 1: CycleGAN
   * 2: GcGAN-vf
   * 3: GcGAN-rot 
   * 4: GAN (mnist to SVHN or  mnist2mnistm) 
exp_id:
   * 0: SVHN, Mnist 
   * 1: MNIST-M, MNIST

lambda_MI 
   * 22: best for GAN and CycleGAN 
   * 20: best for GcGAN

use_reconst_loss:
   * True: use Cycle loss for GcGAN
## Evaluation

To evaluate the model using evaluation method 1 (translated images are used as Test set), run:

```eval
python test_svhn_to_mnist.py --model='' --iter=40000
```
exp_id:
   * 0: SVHN to MNIST
   * 1: MNIST-M to MNIST
   
```eval
python test_mnist_to_svhn.py --model='' --iter=40000
```
exp_id:
   * 0: MNIST to SVHN
   * 1: MNIST to MNIST-M
   

To evaluate the model using evaluation method 2 (translated images are used as Training set), run:

```eval
python new_test_svhn_to_mnist.py --model='' --iter=40000
```
exp_id:
   * 0: SVHN to MNIST
   * 1: MNIST-M to MNIST
   
```eval
python new_test_mnist_to_svhn.py --model='' --iter=40000
```
exp_id:
   * 0: MNIST to SVHN
   * 1: MNIST to MNIST-M
   
   
The results is shown at the Tabel 1 of the sumbimission paper.